<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseItinerary ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseItinerary extends AbstractStructArrayBase
{
    /**
     * The CruiseItinerary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseItinerary[]
     */
    public $CruiseItinerary;
    /**
     * Constructor method for ArrayOfJP_CruiseItinerary
     * @uses ArrayOfJP_CruiseItinerary::setCruiseItinerary()
     * @param \StructType\JP_CruiseItinerary[] $cruiseItinerary
     */
    public function __construct(array $cruiseItinerary = array())
    {
        $this
            ->setCruiseItinerary($cruiseItinerary);
    }
    /**
     * Get CruiseItinerary value
     * @return \StructType\JP_CruiseItinerary[]|null
     */
    public function getCruiseItinerary()
    {
        return $this->CruiseItinerary;
    }
    /**
     * This method is responsible for validating the values passed to the setCruiseItinerary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCruiseItinerary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCruiseItineraryForArrayConstraintsFromSetCruiseItinerary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_CruiseItineraryCruiseItineraryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseItineraryCruiseItineraryItem instanceof \StructType\JP_CruiseItinerary) {
                $invalidValues[] = is_object($arrayOfJP_CruiseItineraryCruiseItineraryItem) ? get_class($arrayOfJP_CruiseItineraryCruiseItineraryItem) : sprintf('%s(%s)', gettype($arrayOfJP_CruiseItineraryCruiseItineraryItem), var_export($arrayOfJP_CruiseItineraryCruiseItineraryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CruiseItinerary property can only contain items of type \StructType\JP_CruiseItinerary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CruiseItinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseItinerary[] $cruiseItinerary
     * @return \ArrayType\ArrayOfJP_CruiseItinerary
     */
    public function setCruiseItinerary(array $cruiseItinerary = array())
    {
        // validation for constraint: array
        if ('' !== ($cruiseItineraryArrayErrorMessage = self::validateCruiseItineraryForArrayConstraintsFromSetCruiseItinerary($cruiseItinerary))) {
            throw new \InvalidArgumentException($cruiseItineraryArrayErrorMessage, __LINE__);
        }
        $this->CruiseItinerary = $cruiseItinerary;
        return $this;
    }
    /**
     * Add item to CruiseItinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseItinerary $item
     * @return \ArrayType\ArrayOfJP_CruiseItinerary
     */
    public function addToCruiseItinerary(\StructType\JP_CruiseItinerary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseItinerary) {
            throw new \InvalidArgumentException(sprintf('The CruiseItinerary property can only contain items of type \StructType\JP_CruiseItinerary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CruiseItinerary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseItinerary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseItinerary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseItinerary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseItinerary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseItinerary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CruiseItinerary
     */
    public function getAttributeName()
    {
        return 'CruiseItinerary';
    }
}
